#include <iostream>

using namespace std;
int br1[200001],a[200001],rez[200001];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    bool jeste=true;
    int n,q,i,j,p,l,r,stepen=1;
    cin >> n >> q;
    for(i=1;i<=n;i++)
    {
        cin >> a[i];
        if(a[i]!=1 && a[i]!=0)
            jeste=false;
        if(a[i]==0)
            br1[i]=br1[i-1];
        else
            br1[i]=br1[i-1]+1;
    }
    for(i=0;i<q;i++)
    {
        cin >> l >> r;
        if(jeste==true)
        {
            if(br1[r]-br1[l-1]==r-l+1)
                rez[i]=1;
            else
                rez[i]=0;
        }
        else
        {
            rez[i]=a[l];
            for(j=l+1;j<=r;j++)
                rez[i]=(rez[i]&a[j]);
        }
    }
    for(i=0;i<q;i++)
        cout << rez[i] << endl;
    //cout << "Hello world!" << endl;
    return 0;
}